﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.Linq;
using Sz;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Text;
using System.Threading.Tasks;

namespace UnitTestProject1
{
    
    [TestClass]
    public class UnitTest1
    {
        public static double[][] ConvertToDoubleArray(string[] arrayString) => arrayString.Select(line => line.Split(' ').Select(double.Parse).ToArray()).ToArray();
        public static int[][] ConvertToIntArray(string[] arrayString) => arrayString.Select(line => line.Split(' ').Select(int.Parse).ToArray()).ToArray();
        public string inputPath = "D:\\Rzaev_Examen\\source\\repos\\ConsoleApp1\\input.txt";
        public string outputPath = "output.txt";
        [TestMethod]
        public void TestOfCorrectType1()
        {
            string[] allLines = File.ReadAllLines(inputPath);
            int separatorOrig = Array.IndexOf(allLines, "-");

            string[] transportTaskOne = allLines.Take(separatorOrig).ToArray();
            int separatorOne = Array.IndexOf(transportTaskOne, "/");
            string[] arrayTarifOne = transportTaskOne.Take(separatorOne).ToArray();
            double[][] arrayTarOne = ConvertToDoubleArray(arrayTarifOne);

            string[] suppliersAndCustomersOne = transportTaskOne.Skip(separatorOne + 1).ToArray();
            int[][] suppliesrAndCustOne = ConvertToIntArray(suppliersAndCustomersOne);

            var type = typeof(double[][]);


            SeverZapad objOne = new SeverZapad(arrayTarOne, suppliesrAndCustOne);
            Assert.IsInstanceOfType(objOne.arrayTarif, typeof(double[][]));
        }

        [TestMethod]
        public void TestOfCorrectReturn()
        {
            string[] allLines = File.ReadAllLines(inputPath);
            int separatorOrig = Array.IndexOf(allLines, "-");

            string[] transportTaskOne = allLines.Take(separatorOrig).ToArray();
            int separatorOne = Array.IndexOf(transportTaskOne, "/");
            string[] arrayTarifOne = transportTaskOne.Take(separatorOne).ToArray();
            double[][] arrayTarOne = ConvertToDoubleArray(arrayTarifOne);

            string[] suppliersAndCustomersOne = transportTaskOne.Skip(separatorOne + 1).ToArray();
            int[][] suppliesrAndCustOne = ConvertToIntArray(suppliersAndCustomersOne);

            var test_result = typeof(string);


            SeverZapad objOne = new SeverZapad(arrayTarOne, suppliesrAndCustOne);
            Assert.IsInstanceOfType(objOne.ToString(), test_result);
        }
        [TestMethod]
        public void TestOfCorrectTypearrayDelivery()
        {
            string[] allLines = File.ReadAllLines(inputPath);
            int separatorOrig = Array.IndexOf(allLines, "-");

            string[] transportTaskOne = allLines.Take(separatorOrig).ToArray();
            int separatorOne = Array.IndexOf(transportTaskOne, "/");
            string[] arrayTarifOne = transportTaskOne.Take(separatorOne).ToArray();
            double[][] arrayTarOne = ConvertToDoubleArray(arrayTarifOne);

            string[] suppliersAndCustomersOne = transportTaskOne.Skip(separatorOne + 1).ToArray();
            int[][] suppliesrAndCustOne = ConvertToIntArray(suppliersAndCustomersOne);

            var type = typeof(int[][]);


            SeverZapad objOne = new SeverZapad(arrayTarOne, suppliesrAndCustOne);
            Assert.IsInstanceOfType(objOne.arrayDelivery, type);
        }
        [TestMethod]
        public void TestOfCorrectTypeSuppliers()
        {
            string[] allLines = File.ReadAllLines(inputPath);
            int separatorOrig = Array.IndexOf(allLines, "-");

            string[] transportTaskOne = allLines.Take(separatorOrig).ToArray();
            int separatorOne = Array.IndexOf(transportTaskOne, "/");
            string[] arrayTarifOne = transportTaskOne.Take(separatorOne).ToArray();
            double[][] arrayTarOne = ConvertToDoubleArray(arrayTarifOne);

            string[] suppliersAndCustomersOne = transportTaskOne.Skip(separatorOne + 1).ToArray();
            int[][] suppliesrAndCustOne = ConvertToIntArray(suppliersAndCustomersOne);

            var type = typeof(int[]);


            SeverZapad objOne = new SeverZapad(arrayTarOne, suppliesrAndCustOne);
            Assert.IsInstanceOfType(objOne.suppliers, type);
        }
        [TestMethod]
        public void TestOfCorrectTypeTargetFunction()
        {
            string[] allLines = File.ReadAllLines(inputPath);
            int separatorOrig = Array.IndexOf(allLines, "-");

            string[] transportTaskOne = allLines.Take(separatorOrig).ToArray();
            int separatorOne = Array.IndexOf(transportTaskOne, "/");
            string[] arrayTarifOne = transportTaskOne.Take(separatorOne).ToArray();
            double[][] arrayTarOne = ConvertToDoubleArray(arrayTarifOne);

            string[] suppliersAndCustomersOne = transportTaskOne.Skip(separatorOne + 1).ToArray();
            int[][] suppliesrAndCustOne = ConvertToIntArray(suppliersAndCustomersOne);

            var type = typeof(double);


            SeverZapad objOne = new SeverZapad(arrayTarOne, suppliesrAndCustOne);
            Assert.IsInstanceOfType(objOne.targetFunction, type);
        }
    }
}
